       IDENTIFICATION DIVISION.
       PROGRAM-ID.    CBLCLTC1.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2019 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy and modify this software for any      *
      * non-commercial purpose and without fee is hereby granted,     *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used in *
      * any advertising or publicity pertaining to the use of the     *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
      * Source Member: CBLCLTC1.CBL
      * Copy Files:    PASSRA12.CPY
      * Calls to:      SIMORA12
      *****************************************************************
      *
      *                   ************
      *                   * CBLCLTJ1 *
      *                   ********jcl*
      *                        *
      *                   ************
      *                   * IEFBR14  *
      *                   ********utl*
      *                        *
      *  ************     ************     ************
      *  * COLLATE1 *-----* CBLCLTC1 *-----* COLLATE2 *
      *  ********dat*     ********cbl*     ********dat*
      *                        *
      *                        *
      *                   ************
      *                   *   EOJ    *
      *                   ************
      *
      * The purpose of this program is to shaow an example of code
      * that will execute correctly in an EBCDIC environment but
      * fail in an ASCII environment.
      *
      *****************************************************************

       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT COLLATE1-FILE  ASSIGN to     COLLATE1
                  ORGANIZATION is SEQUENTIAL
                  ACCESS MODE  is SEQUENTIAL
                  FILE STATUS  is COLLATE1-STATUS.
           SELECT COLLATE2-FILE  ASSIGN to     COLLATE2
                  ORGANIZATION is SEQUENTIAL
                  ACCESS MODE  is SEQUENTIAL
                  FILE STATUS  is COLLATE2-STATUS.

      *****************************************************************
       DATA DIVISION.
       FILE SECTION.
       FD  COLLATE1-FILE
           BLOCK CONTAINS 00800 CHARACTERS
           DATA RECORD    is COLLATE1-RECORD
           .
       01  COLLATE1-RECORD.
           05  COLLATE1-DATA-01.
               10  COLLATE1-FIRST-BYTE pic X.
               10  COLLATE1-2-80       pic X(79).

       FD  COLLATE2-FILE
           BLOCK CONTAINS 00800 CHARACTERS
           DATA RECORD    is COLLATE2-RECORD
           .
       01  COLLATE2-RECORD.
           05  COLLATE2-DATA-01  pic X(00080).

       WORKING-STORAGE SECTION.
       01  SIM-TITLE.
           05  T1 pic X(11) value '* CBLCLTC1 '.
           05  T2 pic X(34) value 'Test for ASCII/EBCDIC collating   '.
           05  T3 pic X(10) value ' v07.07.30'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* CBLCLTC1 '.
           05  C2 pic X(20) value 'Copyright 1987-2019 '.
           05  C3 pic X(28) value '   SimoTime Technologies    '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  SIM-THANKS-01.
           05  C1 pic X(11) value '* CBLCLTC1 '.
           05  C2 pic X(32) value 'Thank you for using this program'.
           05  C3 pic X(32) value ' provided from SimoTime Technolo'.
           05  C4 pic X(04) value 'gies'.

       01  SIM-THANKS-02.
           05  C1 pic X(11) value '* CBLCLTC1 '.
           05  C2 pic X(32) value 'Please send all inquires or sugg'.
           05  C3 pic X(32) value 'estions to the helpdesk@simotime'.
           05  C4 pic X(04) value '.com'.

       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* CBLCLTC1 '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(68)   value SPACES.
               10  MESSAGE-TEXT-2  pic X(188)  value SPACES.

       01  COLLATE1-STATUS.
           05  COLLATE1-STATUS-L     pic X.
           05  COLLATE1-STATUS-R     pic X.
       01  COLLATE1-EOF              pic X       value 'N'.
       01  COLLATE1-OPEN-FLAG        pic X       value 'C'.

       01  COLLATE2-STATUS.
           05  COLLATE2-STATUS-L     pic X.
           05  COLLATE2-STATUS-R     pic X.
       01  COLLATE2-EOF              pic X       value 'N'.
       01  COLLATE2-OPEN-FLAG        pic X       value 'C'.

       01  IO-STATUS.
           05  IO-STAT1            pic X.
           05  IO-STAT2            pic X.
       01  TWO-BYTES.
           05  TWO-BYTES-LEFT      pic X.
           05  TWO-BYTES-RIGHT     pic X.
       01  TWO-BYTES-BINARY        redefines TWO-BYTES pic 9(4) comp.

       01  APPL-RESULT             pic S9(9)   comp.
           88  APPL-AOK            value 0.
           88  APPL-EOF            value 16.

       01  ONE-BYTE                pic X.

       01  COLLATE1-TOTAL.
           05  filler       pic X(23)  value 'COLLATE1 line count is '.
           05  COLLATE1-LOC pic 9(7) value 0.

      *****************************************************************
       PROCEDURE DIVISION.
           perform Z-POST-COPYRIGHT
           perform COLLATE1-OPEN
           perform COLLATE2-OPEN

           perform until COLLATE1-STATUS not = '00'
               perform COLLATE1-READ
               if  COLLATE1-STATUS = '00'
                   add 1 to COLLATE1-LOC
                   move SPACES to COLLATE2-RECORD
                   move 'Character is ' to COLLATE2-RECORD
                   move COLLATE1-FIRST-BYTE to COLLATE2-RECORD(14:1)

      *            The following logic will produce different results
      *            when in an EBCDIC-encoded or ASCII-encoded
      *            environment. This is because of the difference in
      *            the collating sequences of the two environments.
                   if  COLLATE1-FIRST-BYTE < SPACE
                   or  COLLATE1-FIRST-BYTE > 9
                       move 'NOT Printable'  to COLLATE2-RECORD(16:13)
                   else
                       move 'Printable AOK'  to COLLATE2-RECORD(16:13)
                   end-if
                   move COLLATE1-2-80(1:40) to COLLATE2-RECORD(29:40)
                   if  COLLATE2-RECORD not = SPACES
                       move COLLATE2-RECORD to MESSAGE-TEXT
                       perform Z-DISPLAY-CONSOLE-MESSAGE
                       perform COLLATE2-WRITE
                   end-if
      *            End of example for logic differences

               end-if
           end-perform

           move COLLATE1-TOTAL to MESSAGE-TEXT
           perform Z-DISPLAY-CONSOLE-MESSAGE

           if  COLLATE1-EOF = 'Y'
               move 'is Finished...' to MESSAGE-TEXT
           else
               move 'is ABENDING...' to MESSAGE-TEXT
           end-if
           perform Z-DISPLAY-CONSOLE-MESSAGE

           perform COLLATE2-CLOSE
           perform COLLATE1-CLOSE
           perform Z-THANK-YOU.
           GOBACK.

      *****************************************************************
      * I/O ROUTINES FOR COLLATE1...                                  *
      *****************************************************************
       COLLATE1-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close COLLATE1-FILE
           if  COLLATE1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'COLLATE1-Failure-CLOSE...' to MESSAGE-TEXT
               perform Z-DISPLAY-CONSOLE-MESSAGE
               move COLLATE1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       COLLATE1-READ.
           read COLLATE1-FILE
           if  COLLATE1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  COLLATE1-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if
           if  APPL-AOK
               CONTINUE
           else
               if  APPL-EOF
                   move 'Y' to COLLATE1-EOF
               else
                   move 'COLLATE1-Failure-GET...' to MESSAGE-TEXT
                   perform Z-DISPLAY-CONSOLE-MESSAGE
                   move COLLATE1-STATUS to IO-STATUS
                   perform Z-DISPLAY-IO-STATUS
                   perform Z-ABEND-PROGRAM
               end-if
           end-if
           exit.
      *---------------------------------------------------------------*
       COLLATE1-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open input COLLATE1-FILE
           if  COLLATE1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to COLLATE1-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'COLLATE1-Failure-OPEN...' to MESSAGE-TEXT
               perform Z-DISPLAY-CONSOLE-MESSAGE
               move COLLATE1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * I/O ROUTINES FOR COLLATE2...                                  *
      *****************************************************************
       COLLATE2-WRITE.
           if  COLLATE2-OPEN-FLAG = 'C'
               perform COLLATE2-OPEN
           end-if
           write COLLATE2-RECORD
           if  COLLATE2-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  COLLATE2-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if.
           if  APPL-AOK
               CONTINUE
           else
               move 'COLLATE2-Failure-WRITE...' to MESSAGE-TEXT
               perform Z-DISPLAY-CONSOLE-MESSAGE
               move COLLATE2-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       COLLATE2-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open output COLLATE2-FILE
           if  COLLATE2-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to COLLATE2-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'COLLATE2-Failure-OPEN...' to MESSAGE-TEXT
               perform Z-DISPLAY-CONSOLE-MESSAGE
               move COLLATE2-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       COLLATE2-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close COLLATE2-FILE
           if  COLLATE2-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'C' to COLLATE2-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'COLLATE2-Failure-CLOSE...' to MESSAGE-TEXT
               perform Z-DISPLAY-CONSOLE-MESSAGE
               move COLLATE2-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * The following Z-Routines perform administrative tasks         *
      * for this program.                                             *
      *****************************************************************
      * ABEND the program, post a message to the console and issue    *
      * a STOP RUN.                                                   *
      *****************************************************************
       Z-ABEND-PROGRAM.
           if  MESSAGE-TEXT not = SPACES
               perform Z-DISPLAY-CONSOLE-MESSAGE
           end-if
           move 'PROGRAM-IS-ABENDING...'  to MESSAGE-TEXT
           perform Z-DISPLAY-CONSOLE-MESSAGE
           add 12 to ZERO giving RETURN-CODE
           STOP RUN.
      *    exit.

      *****************************************************************
      * Display CONSOLE messages...                                   *
      *****************************************************************
       Z-DISPLAY-CONSOLE-MESSAGE.
           if MESSAGE-TEXT-2 = SPACES
               display MESSAGE-BUFFER(1:79)
           else
               display MESSAGE-BUFFER
           end-if
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
      * Display the file status bytes. This routine will display as   *
      * two digits if the full two byte file status is numeric. If    *
      * second byte is non-numeric then it will be treated as a       *
      * binary number.                                                *
      *****************************************************************
       Z-DISPLAY-IO-STATUS.
           if  IO-STATUS not NUMERIC
           or  IO-STAT1    = '9'
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move IO-STAT2 to TWO-BYTES-RIGHT
               display '* CBLCLTC1 File-Status-' IO-STAT1 '/'
                       TWO-BYTES-BINARY upon console
           else
               display '* CBLCLTC1 File-Status-' IO-STATUS
           end-if
           exit.

      *****************************************************************
       Z-POST-COPYRIGHT.
           display SIM-TITLE
           display SIM-COPYRIGHT
           exit.

      *****************************************************************
       Z-THANK-YOU.
           display SIM-THANKS-01
           display SIM-THANKS-02
           exit.
      *****************************************************************
      *      This example is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
