       IDENTIFICATION DIVISION.
       PROGRAM-ID.    CBLCLTC2.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2019 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy and modify this software for any      *
      * non-commercial purpose and without fee is hereby granted,     *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used in *
      * any advertising or publicity pertaining to the use of the     *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
      * Source Member: CBLCLTC2.CBL
      * Copy Files:    PASSRA12.CPY
      * Calls to:      SIMORA12
      *****************************************************************
      *
      *                   ************
      *                   * CBLCLTJ2 *
      *                   ********jcl*
      *                        *
      *                   ************
      *                   * IEFBR14  *
      *                   ********utl*
      *                        *
      *                   ************     ************
      *                   * CBLCLTC2 *-----* COLLATE1 *
      *                   ********cbl*     ********dat*
      *                        *
      *                   ************
      *                   *   EOJ    *
      *                   ************
      *
      *****************************************************************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT COLLATE1-FILE  ASSIGN to     COLLATE1
                  ORGANIZATION is SEQUENTIAL
                  ACCESS MODE  is SEQUENTIAL
                  FILE STATUS  is COLLATE1-STATUS.

      *****************************************************************
       DATA DIVISION.
       FILE SECTION.
       FD  COLLATE1-FILE
           BLOCK CONTAINS 00800 CHARACTERS
           DATA RECORD    is COLLATE1-RECORD
           .
       01  COLLATE1-RECORD.
           05  COLLATE1-CHARACTER    pic X.
           05  FILLER                pic X.
           05  COLLATE1-DESCRIPTION  pic X(78).

       WORKING-STORAGE SECTION.
       01  SIM-TITLE.
           05  T1 pic X(11) value '* CBLCLTC2 '.
           05  T2 pic X(34) value 'Create Input for Collating        '.
           05  T3 pic X(10) value ' v12.05.09'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* CBLCLTC2 '.
           05  C2 pic X(20) value 'Copyright 1987-2019 '.
           05  C3 pic X(28) value '   SimoTime Technologies    '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  SIM-THANKS-01.
           05  C1 pic X(11) value '* CBLCLTC2 '.
           05  C2 pic X(32) value 'Thank you for using this program'.
           05  C3 pic X(32) value ' provided from SimoTime Technolo'.
           05  C4 pic X(04) value 'gies'.

       01  SIM-THANKS-02.
           05  C1 pic X(11) value '* CBLCLTC2 '.
           05  C2 pic X(32) value 'Please send all inquires or sugg'.
           05  C3 pic X(32) value 'estions to the helpdesk@simotime'.
           05  C4 pic X(04) value '.com'.

       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* CBLCLTC2 '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(68)   value SPACES.
               10  MESSAGE-TEXT-2  pic X(188)  value SPACES.

       01  COLLATE1-STATUS.
           05  COLLATE1-STATUS-L     pic X.
           05  COLLATE1-STATUS-R     pic X.
       01  COLLATE1-EOF              pic X       value 'N'.
       01  COLLATE1-OPEN-FLAG        pic X       value 'C'.

       01  IO-STATUS.
           05  IO-STAT1            pic X.
           05  IO-STAT2            pic X.
       01  TWO-BYTES.
           05  TWO-BYTES-LEFT      pic X.
           05  TWO-BYTES-RIGHT     pic X.
       01  TWO-BYTES-BINARY        redefines TWO-BYTES pic 9(4) comp.

       01  APPL-RESULT             pic S9(9)   comp.
           88  APPL-AOK            value 0.
           88  APPL-EOF            value 16.

       01  COLLATE1-TOTAL.
           05  filler      pic X(23)  value 'COLLATE1 line count is '.
           05  COLLATE-LOC pic 9(7)   value 0.

       01  ONE-BYTE                pic X.
       01  ONE-DIGIT               pic 9       value 0.
       01  WORK-20                 pic X(20).
       01  PTR-01                  pic 9(3)    value 0.
       01  UPPER-CASE  pic X(26)   value 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'.
       01  LOWER-CASE  pic X(26)   value 'abcdefghijklmnopqrstuvwxyz'.
      *
       01  DIGITS-DATA.
           05  FILLER pic X(18) value '0 e=F0 a=30, Digit'.
           05  FILLER pic X(18) value '1 e=F1 a=31, Digit'.
           05  FILLER pic X(18) value '2 e=F2 a=32, Digit'.
           05  FILLER pic X(18) value '3 e=F3 a=33, Digit'.
           05  FILLER pic X(18) value '4 e=F4 a=34, Digit'.
           05  FILLER pic X(18) value '5 e=F5 a=35, Digit'.
           05  FILLER pic X(18) value '6 e=F6 a=36, Digit'.
           05  FILLER pic X(18) value '7 e=F7 a=37, Digit'.
           05  FILLER pic X(18) value '8 e=F8 a=38, Digit'.
           05  FILLER pic X(18) value '9 e=F9 a=39, Digit'.
       01  DIGITS-INFO redefines DIGITS-DATA.
           05  DIGITS-TABLE    pic X(18) occurs 10 times.
      *
       01  UPPER-DATA.
           05  FILLER pic X(23) value 'A e=C1 a=41, Upper-Case'.
           05  FILLER pic X(23) value 'B e=C2 a=42, Upper-Case'.
           05  FILLER pic X(23) value 'C e=C3 a=43, Upper-Case'.
           05  FILLER pic X(23) value 'D e=C4 a=44, Upper-Case'.
           05  FILLER pic X(23) value 'E e=C5 a=45, Upper-Case'.
           05  FILLER pic X(23) value 'F e=C6 a=46, Upper-Case'.
           05  FILLER pic X(23) value 'G e=C7 a=47, Upper-Case'.
           05  FILLER pic X(23) value 'H e=C8 a=48, Upper-Case'.
           05  FILLER pic X(23) value 'I e=C9 a=49, Upper-Case'.
           05  FILLER pic X(23) value 'J e=D1 a=4A, Upper-Case'.
           05  FILLER pic X(23) value 'K e=D2 a=4B, Upper-Case'.
           05  FILLER pic X(23) value 'L e=D3 a=4C, Upper-Case'.
           05  FILLER pic X(23) value 'M e=D4 a=4D, Upper-Case'.
           05  FILLER pic X(23) value 'N e=D5 a=4E, Upper-Case'.
           05  FILLER pic X(23) value 'O e=D6 a=4F, Upper-Case'.
           05  FILLER pic X(23) value 'P e=D7 a=50, Upper-Case'.
           05  FILLER pic X(23) value 'Q e=D8 a=51, Upper-Case'.
           05  FILLER pic X(23) value 'R e=D9 a=52, Upper-Case'.
           05  FILLER pic X(23) value 'S e=E2 a=53, Upper-Case'.
           05  FILLER pic X(23) value 'T e=E3 a=54, Upper-Case'.
           05  FILLER pic X(23) value 'U e=E4 a=55, Upper-Case'.
           05  FILLER pic X(23) value 'V e=E5 a=56, Upper-Case'.
           05  FILLER pic X(23) value 'W e=E6 a=57, Upper-Case'.
           05  FILLER pic X(23) value 'X e=E7 a=58, Upper-Case'.
           05  FILLER pic X(23) value 'Y e=E8 a=59, Upper-Case'.
           05  FILLER pic X(23) value 'Z e=E9 a=5A, Upper-Case'.
       01  UPPER-INFO redefines UPPER-DATA.
           05  UPPER-TABLE    pic X(23) occurs 26 times.
      *
       01  LOWER-DATA.
           05  FILLER pic X(23) value 'a e=81 a=61, Lower-Case'.
           05  FILLER pic X(23) value 'b e=82 a=62, Lower-Case'.
           05  FILLER pic X(23) value 'c e=83 a=63, Lower-Case'.
           05  FILLER pic X(23) value 'd e=84 a=64, Lower-Case'.
           05  FILLER pic X(23) value 'e e=85 a=65, Lower-Case'.
           05  FILLER pic X(23) value 'f e=86 a=66, Lower-Case'.
           05  FILLER pic X(23) value 'g e=87 a=67, Lower-Case'.
           05  FILLER pic X(23) value 'h e=88 a=68, Lower-Case'.
           05  FILLER pic X(23) value 'i e=89 a=69, Lower-Case'.
           05  FILLER pic X(23) value 'j e=91 a=6A, Lower-Case'.
           05  FILLER pic X(23) value 'k e=92 a=6B, Lower-Case'.
           05  FILLER pic X(23) value 'l e=93 a=6C, Lower-Case'.
           05  FILLER pic X(23) value 'm e=94 a=6D, Lower-Case'.
           05  FILLER pic X(23) value 'n e=95 a=6E, Lower-Case'.
           05  FILLER pic X(23) value 'o e=96 a=6F, Lower-Case'.
           05  FILLER pic X(23) value 'p e=97 a=70, Lower-Case'.
           05  FILLER pic X(23) value 'q e=98 a=71, Lower-Case'.
           05  FILLER pic X(23) value 'r e=99 a=72, Lower-Case'.
           05  FILLER pic X(23) value 's e=A2 a=73, Lower-Case'.
           05  FILLER pic X(23) value 't e=A3 a=74, Lower-Case'.
           05  FILLER pic X(23) value 'u e=A4 a=75, Lower-Case'.
           05  FILLER pic X(23) value 'v e=A5 a=76, Lower-Case'.
           05  FILLER pic X(23) value 'w e=A6 a=77, Lower-Case'.
           05  FILLER pic X(23) value 'x e=A7 a=78, Lower-Case'.
           05  FILLER pic X(23) value 'y e=A8 a=79, Lower-Case'.
           05  FILLER pic X(23) value 'z e=A9 a=7A, Lower-Case'.
       01  LOWER-INFO redefines LOWER-DATA.
           05  LOWER-TABLE    pic X(23) occurs 26 times.
      *
       01  SPECIAL-DATA.
           05  FILLER pic X(30) value '  e=40 a=20, Space Character  '.
           05  FILLER pic X(30) value '" e=7F a=22, Double Quote     '.
           05  FILLER pic X(30) value "' e=7D a=27, Apostrophe       ".
           05  FILLER pic X(30) value '~ e=A1 a=7E, Tilde            '.
           05  FILLER pic X(30) value '! e=5A a=21, Exclamation Point'.
           05  FILLER pic X(30) value '@ e=7C a=40, At Sign          '.
           05  FILLER pic X(30) value '# e=7B a=23, Square Symbol    '.
           05  FILLER pic X(30) value '$ e=5B a=24, Dollar Sign      '.
           05  FILLER pic X(30) value '% e=6C a=25, Per Cent Sign    '.
           05  FILLER pic X(30) value '^ e=B0 a=5E, Carat Symbol     '.
           05  FILLER pic X(30) value '& e=50 a=26, Ampersand        '.
           05  FILLER pic X(30) value '* e=5C a=2A, Asterisk         '.
           05  FILLER pic X(30) value '( e=4D a=28, Left Parenthesis '.
           05  FILLER pic X(30) value ') e=5D a=29, Right Parenthesis'.
           05  FILLER pic X(30) value '_ e=6D a=5F, Underscore       '.
           05  FILLER pic X(30) value '+ e=4E a=2B, Plus Sign        '.
           05  FILLER pic X(30) value '{ e=C0 a=7B, Left Brace       '.
           05  FILLER pic X(30) value '} e=D0 a=7D, Right Brace      '.
           05  FILLER pic X(30) value '| e=4F a=7C, Vertical Bar     '.
           05  FILLER pic X(30) value ': e=7A a=3A, Colon            '.
           05  FILLER pic X(30) value '< e=4C a=3C, Less Than        '.
           05  FILLER pic X(30) value '> e=6E a=3E, Greater Than     '.
           05  FILLER pic X(30) value '? e=6F a=3F, Question Mark    '.
           05  FILLER pic X(30) value '` e=79 a=60, Back Apostrophe  '.
           05  FILLER pic X(30) value '- e=60 a=2D, Minus Sign       '.
           05  FILLER pic X(30) value '= e=7E a=3D, Equal Sign       '.
           05  FILLER pic X(30) value '[ e=AD a=5B, Left Bracket     '.
           05  FILLER pic X(30) value '] e=BD a=5D, Right Bracket    '.
           05  FILLER pic X(30) value '\ e=E0 a=5C, Back Slash       '.
           05  FILLER pic X(30) value '; e=5E a=3B, Semicolon        '.
           05  FILLER pic X(30) value ', e=6B a=2C, Comma            '.
           05  FILLER pic X(30) value '. e=4B a=2E, Period Full Stop '.
           05  FILLER pic X(30) value '/ e=61 a=2F, Forward Slash    '.
       01  SPECIAL-INFO redefines SPECIAL-DATA.
           05  SPECIAL-TABLE    pic X(30) occurs 33 times.
      *****************************************************************
       PROCEDURE DIVISION.
           perform Z-POST-COPYRIGHT
           perform COLLATE1-OPEN

           move SPACES to COLLATE1-RECORD

           perform WRITE-RECORDS-WITH-DIGITS
           perform WRITE-RECORDS-WITH-UPPER-CASE
           perform WRITE-RECORDS-WITH-LOWER-CASE
           perform WRITE-RECORDS-WITH-SPECIAL

           move COLLATE1-TOTAL to MESSAGE-TEXT
           perform Z-DISPLAY-CONSOLE-MESSAGE

           if  COLLATE-LOC > 0
               move 'is Finished...' to MESSAGE-TEXT
           else
               move 'is ABENDING...' to MESSAGE-TEXT
           end-if
           perform Z-DISPLAY-CONSOLE-MESSAGE

           perform COLLATE1-CLOSE
           perform Z-THANK-YOU.
           GOBACK.

      *****************************************************************
       WRITE-RECORDS-WITH-DIGITS.
           add 1 to ZERO giving PTR-01
           move SPACES to COLLATE1-RECORD
           perform 10 times
               move DIGITS-TABLE(PTR-01) to COLLATE1-RECORD
               perform COLLATE1-WRITE
               add 1 to PTR-01
           end-perform
           exit.

      *****************************************************************
       WRITE-RECORDS-WITH-LOWER-CASE.
           add 1 to ZERO giving PTR-01
           move SPACES to COLLATE1-RECORD
           perform 26 times
               move LOWER-TABLE(PTR-01) to COLLATE1-RECORD
               perform COLLATE1-WRITE
               add 1 to PTR-01
           end-perform
           exit.

      *****************************************************************
       WRITE-RECORDS-WITH-UPPER-CASE.
           add 1 to ZERO giving PTR-01
           move SPACES to COLLATE1-RECORD
           perform 26 times
               move UPPER-TABLE(PTR-01) to COLLATE1-RECORD
               perform COLLATE1-WRITE
               add 1 to PTR-01
           end-perform
           exit.

      *****************************************************************
       WRITE-RECORDS-WITH-SPECIAL.
           add 1 to ZERO giving PTR-01
           move SPACES to COLLATE1-RECORD
           perform 33 times
               move SPECIAL-TABLE(PTR-01) to COLLATE1-RECORD
               perform COLLATE1-WRITE
               add 1 to PTR-01
           end-perform
           exit.

      *****************************************************************
      * I/O ROUTINES FOR COLLATE1...                                  *
      *****************************************************************
       COLLATE1-WRITE.
           if  COLLATE1-OPEN-FLAG = 'C'
               perform COLLATE1-OPEN
           end-if
           write COLLATE1-RECORD
           if  COLLATE1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               add 1 to COLLATE-LOC
           else
               if  COLLATE1-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if.
           if  APPL-AOK
               CONTINUE
           else
               move 'COLLATE1-Failure-WRITE...' to MESSAGE-TEXT
               perform Z-DISPLAY-CONSOLE-MESSAGE
               move COLLATE1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       COLLATE1-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open output COLLATE1-FILE
           if  COLLATE1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to COLLATE1-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'COLLATE1-Failure-OPEN...' to MESSAGE-TEXT
               perform Z-DISPLAY-CONSOLE-MESSAGE
               move COLLATE1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       COLLATE1-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close COLLATE1-FILE
           if  COLLATE1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'C' to COLLATE1-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'COLLATE1-Failure-CLOSE...' to MESSAGE-TEXT
               perform Z-DISPLAY-CONSOLE-MESSAGE
               move COLLATE1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * The following Z-Routines perform administrative tasks         *
      * for this program.                                             *
      *****************************************************************
      * ABEND the program, post a message to the console and issue    *
      * a STOP RUN.                                                   *
      *****************************************************************
       Z-ABEND-PROGRAM.
           if  MESSAGE-TEXT not = SPACES
               perform Z-DISPLAY-CONSOLE-MESSAGE
           end-if
           move 'PROGRAM-IS-ABENDING...'  to MESSAGE-TEXT
           perform Z-DISPLAY-CONSOLE-MESSAGE
           add 12 to ZERO giving RETURN-CODE
           STOP RUN.
      *    exit.

      *****************************************************************
      * Display CONSOLE messages...                                   *
      *****************************************************************
       Z-DISPLAY-CONSOLE-MESSAGE.
           if MESSAGE-TEXT-2 = SPACES
               display MESSAGE-BUFFER(1:79)
           else
               display MESSAGE-BUFFER
           end-if
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
      * Display the file status bytes. This routine will display as   *
      * two digits if the full two byte file status is numeric. If    *
      * second byte is non-numeric then it will be treated as a       *
      * binary number.                                                *
      *****************************************************************
       Z-DISPLAY-IO-STATUS.
           if  IO-STATUS not NUMERIC
           or  IO-STAT1    = '9'
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move IO-STAT2 to TWO-BYTES-RIGHT
               display '* CBLCLTC2 File-Status-' IO-STAT1 '/'
                       TWO-BYTES-BINARY upon console
           else
               display '* CBLCLTC2 File-Status-' IO-STATUS
           end-if
           exit.

      *****************************************************************
       Z-POST-COPYRIGHT.
           display SIM-TITLE
           display SIM-COPYRIGHT
           exit.

      *****************************************************************
       Z-THANK-YOU.
           display SIM-THANKS-01
           display SIM-THANKS-02
           exit.
      *****************************************************************
      *      This example is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
