//CBLCLTJ1 JOB SIMOTIME,CLASS=1,MSGCLASS=0,NOTIFY=CSIP1
//* *******************************************************************
//*       CBLCLTJ1.JCL - a JCL Member for Batch Job Processing        *
//*       This JCL Member is provided by SimoTime Technologies        *
//*           (C) Copyright 1987-2019 All Rights Reserved             *
//*             Web Site URL:   http://www.simotime.com               *
//*                   e-mail:   helpdesk@simotime.com                 *
//* *******************************************************************
//*
//* Text   - Create, Sort and Process a Sequential file
//*          using a COBOL program.
//* Author - SimoTime Technologies
//* Date   - January 24, 1991
//*
//* The 1st step (QSAMDELT) will delete any previously created file.
//*
//* The 2nd step (MAKEFILE) will create a new file. The first
//* position in each record will contain a printable character.
//*
//* The 3rd step will show a program that works properly in an
//* EBCDIC environment but fails in an ASCII environment.
//*
//* The 4th step will SORT the file. This step will produce different
//* results when executing within an EBCDIC or ASCII environment.
//*
//* The 5th step shows the sequencing for the two environments and
//* will worked properly in an EBCDIC environment but fail in an
//* ASCII environment.
//*
//* This set of programs may be compiled and executed on a Mainframe
//* System with ZOS or a Linux, UNIX or Windows System with Micro Focus
//* Enterprise Server.
//*
//* *******************************************************************
//* Step 1 of 5, Delete any previously created file...
//*
//JOBSETUP EXEC PGM=IEFBR14
//COLLATE1 DD  DSN=SIMOTIME.DATA.COLLATE1,DISP=(MOD,DELETE,DELETE),
//             STORCLAS=MFI,
//             SPACE=(TRK,5),
//             DCB=(RECFM=FB,LRECL=80,BLKSIZE=800,DSORG=PS)
//COLLATE2 DD  DSN=SIMOTIME.DATA.COLLATE2,DISP=(MOD,DELETE,DELETE),
//             STORCLAS=MFI,
//             SPACE=(TRK,5),
//             DCB=(RECFM=FB,LRECL=80,BLKSIZE=8000,DSORG=PS)
//COLLATE3 DD  DSN=SIMOTIME.DATA.COLLATE3,DISP=(MOD,DELETE,DELETE),
//             STORCLAS=MFI,
//             SPACE=(TRK,5),
//             DCB=(RECFM=FB,LRECL=80,BLKSIZE=8000,DSORG=PS)
//COLLATE4  DD  DSN=SIMOTIME.DATA.COLLATE4,DISP=(MOD,DELETE,DELETE),
//             STORCLAS=MFI,
//             SPACE=(TRK,5),
//             DCB=(RECFM=FB,LRECL=80,BLKSIZE=8000,DSORG=PS)
//*
//* *******************************************************************
//* Step 2 of 5, Create and populate a new QSAM file...
//*
//MAKEFILE EXEC PGM=CBLCLTC2
//COLLATE1 DD  DSN=SIMOTIME.DATA.COLLATE1,
//             DISP=(NEW,CATLG,DELETE),
//             STORCLAS=MFI,
//             SPACE=(TRK,5),
//             DCB=(RECFM=FB,LRECL=80,BLKSIZE=800,DSORG=PS)
//*
//* *******************************************************************
//* Step 3 of 5, Test for print character, create a new output file.
//*              the program used in this step will perform correctly
//*              in an EBCDIC environment but fail in an ASCII
//*              environment
//*
//TEST0001 EXEC PGM=CBLCLTC1
//STEPLIB  DD  DSN=SIMOTIME.DEMO.LOADLIB1,DISP=SHR
//COLLATE1 DD  DSN=SIMOTIME.DATA.COLLATE1,DISP=SHR
//COLLATE2 DD  DSN=SIMOTIME.DATA.COLLATE2,
//             DISP=(NEW,CATLG,DELETE),
//             STORCLAS=MFI,
//             SPACE=(TRK,5),
//             DCB=(RECFM=FB,LRECL=80,BLKSIZE=800,DSORG=PS)
//SYSOUT   DD  SYSOUT=*
//* *******************************************************************
//* Step 4 of 5, Sort by character set using a cobol program. This step
//*              will produce different sequencing results when running
//*              in an EBCDIC or ASCII environment.
//*              The major difference is the numbers are sorted after
//*              the alphabetic characters for the EBCDIC environment
//*              and the numbers are sorted before the alhpabetic
//*              characters for the ASCII environment.
//*
//SORTFILE EXEC PGM=CBLS80C1
//STEPLIB  DD  DSN=SIMOTIME.DEMO.LOADLIB1,DISP=SHR
//SORTGET1 DD  DSN=SIMOTIME.DATA.COLLATE1,DISP=SHR
//SORTPUT1 DD  DSN=SIMOTIME.DATA.COLLATE3,DISP=(NEW,CATLG,DELETE),
//             STORCLAS=MFI,
//             SPACE=(TRK,5),
//             DCB=(RECFM=FB,LRECL=80,BLKSIZE=8000,DSORG=PS)
//SYSOUT   DD  SYSOUT=*
//*
//* *******************************************************************
//* Step 5 of 5, Test for print character, create a new output file.
//*              The program used in this step will perform correctly
//*              in an EBCDIC environment but fail in an ASCII
//*              environment.
//*              This step uses the sorted file and shows the sequencing
//*              sequencing that will be different when running in an
//*              EBCDIC or ASCII environment.
//*
//TEST0002 EXEC PGM=CBLCLTC1
//STEPLIB  DD  DSN=SIMOTIME.DEMO.LOADLIB1,DISP=SHR
//COLLATE1 DD  DSN=SIMOTIME.DATA.COLLATE3,DISP=SHR
//COLLATE2 DD  DSN=SIMOTIME.DATA.COLLATE4,
//             DISP=(NEW,CATLG,DELETE),
//             STORCLAS=MFI,
//             SPACE=(TRK,5),
//             DCB=(RECFM=FB,LRECL=80,BLKSIZE=800,DSORG=PS)
//SYSOUT   DD  SYSOUT=*
//
